import type { AdvancedFilterModel, AgEvent, BaseCellDataType, JoinAdvancedFilterModel } from '@ag-grid-community/core';
interface AdvancedFilterBuilderItemEvent<T extends AdvancedFilterBuilderEvents> extends AgEvent<T> {
    item: AdvancedFilterBuilderItem;
}
export interface AdvancedFilterBuilderAddEvent extends AdvancedFilterBuilderItemEvent<'advancedFilterBuilderAdded'> {
    isJoin: boolean;
}
export interface AdvancedFilterBuilderMoveEvent extends AdvancedFilterBuilderItemEvent<'advancedFilterBuilderMoved'> {
    backwards: boolean;
}
export interface AdvancedFilterBuilderRemoveEvent extends AdvancedFilterBuilderItemEvent<'advancedFilterBuilderRemoved'> {
}
export interface AdvancedFilterBuilderItem {
    filterModel: AdvancedFilterModel | null;
    level: number;
    parent?: JoinAdvancedFilterModel;
    valid: boolean;
    showMove?: boolean;
}
export type CreatePillParams = CreateInputPillParams | CreateSelectPillParams;
interface CreateInputPillParams extends BaseCreatePillParams {
    isSelect: false;
    baseCellDataType: BaseCellDataType;
}
interface CreateSelectPillParams extends BaseCreatePillParams {
    isSelect: true;
    getEditorParams: () => {
        values?: any[];
    };
    pickerAriaLabelKey: string;
    pickerAriaLabelValue: string;
}
interface BaseCreatePillParams {
    key: string;
    displayValue: string;
    cssClass: string;
    update: (key: string) => void;
    ariaLabel: string;
}
export type AdvancedFilterBuilderEvents = 'advancedFilterBuilderAdded' | 'advancedFilterBuilderMoved' | 'advancedFilterBuilderRemoved' | 'advancedFilterBuilderValueChanged' | 'advancedFilterBuilderValidChanged';
export {};
